<?php

class queryTester_mysqli extends queryTester {
	
	/**
     *@param object MySQLi database connection
     */
    public function __construct(mysqli $oDb)
	{
		$this->_oDb = $oDb;
	}
    
    /**
     *Runs a single query, fetching all rows the query returns from the db
     *@param string $sSQL The query to run
     *@return array Results fetched by the query
     */
    protected function _runQuery_Select($sSQL)
    {
        //initialise array to store results fetched from the db
        $aResults = array();
        
        if ( ($oResult = $this->_oDb->query($sSQL)) ) {
				while ( ($aRow = $oResult->fetch_assoc()) ) {
					$aResults[] = $aRow;
				}
				$oResult->close();
        } else {
            throw new Exception('Query failed: '.$sSQL);
        }
        if ($this->_oDb->errno) {
            throw new Exception($this->_oDb->error);
        }
        return $aResults;
    }
	
	/**
     *Runs a single query, returning the number of affected rows in an associative array
     *@param string $sSQL The query to run
     *@return array Array containing the number of rows the query affected
     */
    protected function _runQuery_Update($sSQL)
	{
		if ( ($oResult = $this->_oDb->prepare($sSQL)) && $oResult->execute()) {
			return array('affectedRows' => $oResult->affected_rows);
		}
	}

}