<?php

class queryTester_pdo extends queryTester
{

	/**
     *@param object PDO database connection
     */
    public function __construct(PDO $oDb)
	{
        //rather than doing error checking as part of the query, we just tell PDO to throw an exception if an error occured
		$oDb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$this->_oDb = $oDb;
	}
    
    /**
     *Runs a single query, fetching all rows the query returns from the db
     *@param string $sSQL The query to run
     *@return array Results fetched by the query
     */
    protected function _runQuery_Select($sSQL)
    {
        if ( ($oResult = $this->_oDb->query($sSQL)) ) {
            return $oResult->fetchAll(PDO::FETCH_ASSOC);
        }
    }
	
	/**
     *Runs a single query, returning the number of affected rows in an associative array
     *@param string $sSQL The query to run
     *@return array Array containing the number of rows the query affected
     */
    protected function _runQuery_Update($sSQL)
	{
		 if ( ($oResult = $this->_oDb->query($sSQL)) ) {
			return array('affectedRows' => $oResult->rowCount());
		 }
	}
	
}
